"""Protocol engine errors module."""

from .exceptions import (
    ProtocolEngineError,
    UnexpectedProtocolError,
    FailedToLoadPipetteError,
    PipetteNotAttachedError,
    InvalidSpecificationForRobotTypeError,
    InvalidLoadPipetteSpecsError,
    TipNotAttachedError,
    PickUpTipTipNotAttachedError,
    TipAttachedError,
    CommandDoesNotExistError,
    LabwareNotLoadedError,
    LabwareNotLoadedOnModuleError,
    LabwareNotLoadedOnLabwareError,
    LabwareNotOnDeckError,
    LiquidDoesNotExistError,
    LabwareDefinitionDoesNotExistError,
    LabwareCannotBeStackedError,
    LabwareIsInStackError,
    LabwareOffsetDoesNotExistError,
    LabwareIsNotTipRackError,
    LabwareIsTipRackError,
    LabwareIsAdapterError,
    TouchTipDisabledError,
    WellDoesNotExistError,
    PipetteNotLoadedError,
    ModuleNotLoadedError,
    ModuleNotOnDeckError,
    ModuleNotConnectedError,
    SlotDoesNotExistError,
    CutoutDoesNotExistError,
    FixtureDoesNotExistError,
    AddressableAreaDoesNotExistError,
    FixtureDoesNotProvideAreasError,
    AreaNotInDeckConfigurationError,
    IncompatibleAddressableAreaError,
    FailedToPlanMoveError,
    MustHomeError,
    RunStoppedError,
    SetupCommandNotAllowedError,
    FixitCommandNotAllowedError,
    ModuleNotAttachedError,
    ModuleAlreadyPresentError,
    WrongModuleTypeError,
    ThermocyclerNotOpenError,
    RobotDoorOpenError,
    PipetteMovementRestrictedByHeaterShakerError,
    HeaterShakerLabwareLatchNotOpenError,
    HeaterShakerLabwareLatchStatusUnknown,
    EngageHeightOutOfRangeError,
    NoTargetTemperatureSetError,
    InvalidTargetSpeedError,
    InvalidTargetTemperatureError,
    InvalidBlockVolumeError,
    InvalidHoldTimeError,
    CannotPerformModuleAction,
    PauseNotAllowedError,
    ResumeFromRecoveryNotAllowedError,
    GripperNotAttachedError,
    CannotPerformGripperAction,
    HardwareNotSupportedError,
    LabwareMovementNotAllowedError,
    LabwareIsNotAllowedInLocationError,
    LocationIsOccupiedError,
    LocationNotAccessibleByPipetteError,
    LocationIsStagingSlotError,
    LocationIsLidDockSlotError,
    InvalidAxisForRobotType,
    NotSupportedOnRobotType,
    CommandNotAllowedError,
    InvalidLiquidHeightFound,
    LiquidHeightUnknownError,
    IncompleteLabwareDefinitionError,
    IncompleteWellDefinitionError,
    OperationLocationNotInWellError,
    InvalidDispenseVolumeError,
    StorageLimitReachedError,
)

from .error_occurrence import ErrorOccurrence, ProtocolCommandFailedError

__all__ = [
    # exceptions
    "ProtocolEngineError",
    "UnexpectedProtocolError",
    "FailedToLoadPipetteError",
    "PipetteNotAttachedError",
    "InvalidSpecificationForRobotTypeError",
    "InvalidLoadPipetteSpecsError",
    "TipNotAttachedError",
    "PickUpTipTipNotAttachedError",
    "TipAttachedError",
    "CommandDoesNotExistError",
    "LabwareNotLoadedError",
    "LabwareNotLoadedOnModuleError",
    "LabwareNotLoadedOnLabwareError",
    "LabwareNotOnDeckError",
    "LiquidDoesNotExistError",
    "LabwareDefinitionDoesNotExistError",
    "LabwareCannotBeStackedError",
    "LabwareIsInStackError",
    "LabwareOffsetDoesNotExistError",
    "LabwareIsNotTipRackError",
    "LabwareIsTipRackError",
    "LabwareIsAdapterError",
    "TouchTipDisabledError",
    "WellDoesNotExistError",
    "PipetteNotLoadedError",
    "ModuleNotLoadedError",
    "ModuleNotOnDeckError",
    "ModuleNotConnectedError",
    "SlotDoesNotExistError",
    "CutoutDoesNotExistError",
    "FixtureDoesNotExistError",
    "AddressableAreaDoesNotExistError",
    "FixtureDoesNotProvideAreasError",
    "AreaNotInDeckConfigurationError",
    "IncompatibleAddressableAreaError",
    "FailedToPlanMoveError",
    "MustHomeError",
    "RunStoppedError",
    "SetupCommandNotAllowedError",
    "FixitCommandNotAllowedError",
    "ModuleNotAttachedError",
    "ModuleAlreadyPresentError",
    "WrongModuleTypeError",
    "ThermocyclerNotOpenError",
    "RobotDoorOpenError",
    "PipetteMovementRestrictedByHeaterShakerError",
    "HeaterShakerLabwareLatchNotOpenError",
    "HeaterShakerLabwareLatchStatusUnknown",
    "EngageHeightOutOfRangeError",
    "NoTargetTemperatureSetError",
    "InvalidTargetTemperatureError",
    "InvalidTargetSpeedError",
    "InvalidBlockVolumeError",
    "InvalidHoldTimeError",
    "CannotPerformModuleAction",
    "ResumeFromRecoveryNotAllowedError",
    "PauseNotAllowedError",
    "ProtocolCommandFailedError",
    "GripperNotAttachedError",
    "CannotPerformGripperAction",
    "HardwareNotSupportedError",
    "LabwareMovementNotAllowedError",
    "LabwareIsNotAllowedInLocationError",
    "LocationIsOccupiedError",
    "LocationNotAccessibleByPipetteError",
    "LocationIsStagingSlotError",
    "LocationIsLidDockSlotError",
    "InvalidAxisForRobotType",
    "NotSupportedOnRobotType",
    # error occurrence models
    "ErrorOccurrence",
    "CommandNotAllowedError",
    "InvalidLiquidHeightFound",
    "LiquidHeightUnknownError",
    "IncompleteLabwareDefinitionError",
    "IncompleteWellDefinitionError",
    "OperationLocationNotInWellError",
    "InvalidDispenseVolumeError",
    "StorageLimitReachedError",
]
